#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <ft2build.h>
#include FT_FREETYPE_H
#include FT_XFREE86_H

#define FONT_NAME          "FreeMono.t42"
/*#define FONT_NAME          "CharterBT-Bold.t42"*/
#define EXPECTED_STRING    "Type 42"
    
int
main(int argc, char* argv[])
{
    FT_Library  library    = NULL;
    FT_Face     face       = NULL;
    FT_Error    error      = 0;
     
    const char* file_face = FONT_NAME;
    
    error = FT_Init_FreeType( &library );
    
    if( (error != 0) || (library == NULL) )
    {
        fprintf(stderr, "Cannot initialize a new FreeType library object.\n");
        exit(EXIT_FAILURE);
    }
    
    error = FT_New_Face( library, file_face, 0, &face );                         
    
    if( (error != 0) || (face == NULL) )
    {
        fprintf(stderr, "Cannot create a handle to face object.\n");
        exit(EXIT_FAILURE);
    }

/* Cleanup */
    if( face )
    {
        FT_Done_Face( face ); /* This call results in invalid free() */
    }
    if(library)
    {
        FT_Done_FreeType( library );
    }
    
    return 0;
}
